data segment para
	io8253_0	equ		200h
	io8253_1	equ		201h
	io8253_2	equ		202h
	io8253_k	equ		203h
	io8255_a	equ		210h
	io8255_b	equ		211h
	io8255_c	equ		212h
	io8255_ctl	equ		213h
	ad_io		equ		220h
	data1		db		0
data ends

ss_seg segment stack
	dw	100	dup(0)
ss_seg ends

code segment para
assume cs:code,ds:data,ss:ss_seg
	main proc far
		mov		ax,		data
		mov		ds,		ax
		nop
		mov		dx,		io8255_ctl
		mov		al,		10010011b
		out			dx,		al
		mov		dx,		io8253_k
		mov		al,		36h
		out			dx,		al
		mov		ax,		100
		mov		dx,		io8253_0
		out			dx,		al
		mov		al,		ah
		out			dx,		al
		mov		dx,		io8253_k
		mov		al,		76h
		out			dx,		al
		mov		ax,		260
		mov		dx,		io8253_1
		out			dx,		al
		mov		al,		ah
		out			dx,		al

	lop:
mov     	dx, 		io8255_ctl
       mov     	al,			91h
       out   	  	dx,			al			;control port
       mov     	dx,	 		io8255_b	;set iniatial value
       mov     	al, 			0
       out     	dx, 		al			
    loop1:
       mov     	dx, 		ad_io		;ADC module
       out     	dx, 		al
       mov     	dx, 		ad_io
       add     	dx, 		2
    loop2:
        in      	al, 			dx
        test    	al, 			01h
        jz      	loop2
        mov     	dx, 		ad_io
        inc     	dx
        in      	al, 			dx			;result in reg al 
		
        mov     	data1, 		al			;move reault in al to data1
        mov     	dx, 		io8255_a
        out     	dx, 		al
		and			al,			0ffh
mov		dx,			io8255_b	;output to LED
		out			dx,			al
		jnz			lop3
		inc			al					;prevent value == 0
	lop3:
		mov		bl,		al
	lop4:
		mov		dx,		io8255_c
		in			al,		dx
		and			al,		01h			;whether out1 is low
		jnz			lop4				;wait when low
		mov		dx,		io8255_ctl
		mov		al,		0fh			;set PC7
		out			dx,		al
		mov		dx,		io8253_k
		mov		al,		0b0h
		out			dx,		al
		xor			ax,		ax
		mov		al,		bl
		mov		dx,		io8253_2
		out			dx,		al
		mov		al,		ah
		out			dx,		al
	lop1:
		mov		dx,		io8255_c
		in			al,		dx
		and			al,		02h
		jz			lop1
		mov		dx,		io8255_ctl
		mov		al,		0eh
		out			dx,		al
	lop2:
		mov		dx,		io8255_c
		in			al,		dx
		and			al,		01h
		jz			lop2
       jmp     	loop1
		mov		ax,		4c00h
		int			21h
	main	endp
code ends
	end main
